## qemu-web-desktop 21.05.03

=== src/Makefile ===
# Makefile to install remote-desktop.
# just type: make install
#
# required:
#   apache2 libapache2-mod-perl2 novnc websockify qemu-kvm bridge-utils qemu
#   iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl
#   libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl 
#   libproc-background-perl libproc-processtable-perl libemail-valid-perl 
#   libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl 
#   libemail-valid-perl libjson-perl
#
# NOTES:
#   you may have to tune the path to /etc/apache2/conf-available/serve-cgi-bin.conf
#   or other locations. The current makefile works on Debian-class systems.

all:

install:
	install -D html/desktop/index.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html
	install -D html/desktop/style.css $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html
	install -D html/desktop/images $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html
	install -D html/desktop/machines $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
	install -D -d $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	install -D cgi-bin/qemu-web-desktop.pl $(DESTDIR)$(prefix)/usr/lib/cgi-bin/qemu-web-desktop.pl
	install -D bin/qwdctl $(DESTDIR)$(prefix)/usr/bin
	ln -s $(prefix)/var/lib/qemu-web-desktop/machines.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html
	# configure accounts and permissions
	chmod 755 /etc/qemu-ifup
	adduser --system qemu-web-desktop
	chown -R qemu-web-desktop $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
	find $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop$/html -type f -exec chmod a+r {} +
	find $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop$/html -type d -exec chmod a+rx {} +
	chmod 755 $(DESTDIR)$(prefix)/usr/lib/cgi-bin/qemu-web-desktop.pl
	# add apache configuration for cgi perl
	install apache.conf $(DESTDIR)$(prefix)/etc/apache2/conf-available/qemu-web-desktop.conf
	a2enconf qemu-web-desktop
	a2enmod cgi
	a2enmod include
	service apache2 restart
	qwdctl download

uninstall:
	-rm -rf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop
	-rm -f  $(DESTDIR)$(prefix)/usr/lib/cgi-bin/qemu-web-desktop

.PHONY: all install uninstall

=== debian/changelog ===
qemu-web-desktop (21.05.03-4) unstable; urgency=medium

  * Fix Vcs-* fields.

 -- Roland Mas <lolando@debian.org>  Wed, 09 Jun 2021 13:48:09 +0200

qemu-web-desktop (21.05.03-3) unstable; urgency=medium

  * Remove test code.

 -- Roland Mas <lolando@debian.org>  Wed, 09 Jun 2021 11:41:58 +0200

qemu-web-desktop (21.05.03-2) unstable; urgency=medium

  * Bug fix: "qemu-kvm dependency isn't available on all Architecture:
    any", thanks to Christian Ehrhardt (Closes: #989638).

 -- Roland Mas <lolando@debian.org>  Wed, 09 Jun 2021 11:20:33 +0200

qemu-web-desktop (21.05.03-1) unstable; urgency=medium

  * New upstream release to work around an MPM-ITK quirk.

 -- Roland Mas <lolando@debian.org>  Mon, 17 May 2021 18:51:33 +0200

qemu-web-desktop (21.04.10-2) unstable; urgency=medium

  * Add missing Depends: confget.

 -- Roland Mas <lolando@debian.org>  Tue, 20 Apr 2021 11:37:25 +0200

qemu-web-desktop (21.04.10-1) unstable; urgency=medium

  * Initial upload (closes: #986543).

 -- Roland Mas <lolando@debian.org>  Mon, 12 Apr 2021 12:48:12 +0200

=== debian/control ===
Source: qemu-web-desktop
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Roland Mas <lolando@debian.org>, Emmanuel Farhi <emmanuel.farhi@synchrotron-soleil.fr>
Build-Depends: debhelper (>= 12), dh-apache2, dh-sysuser, pandoc
Standards-Version: 4.1.2
Vcs-Browser: https://salsa.debian.org/debian/qemu-web-desktop
Vcs-Git: https://salsa.debian.org/debian/qemu-web-desktop.git
Homepage: https://gitlab.com/soleil-data-treatment/soleil-software-projects/remote-desktop

Package: qemu-web-desktop
Architecture: amd64 ppc64el arm64
Depends: ${shlibs:Depends}, ${misc:Depends},
  apache2,
  libapache2-mod-perl2,
  libapache2-mpm-itk,
  websockify,
  qemu-system-x86 [amd64],
  qemu-system-arm [arm64],
  qemu-system-ppc [ppc64el],
  bridge-utils,
  qemu,
  iptables,
  dnsmasq,
  libcgi-pm-perl,
  liblist-moreutils-perl,
  libsys-cpu-perl,
  libsys-cpuload-perl,
  libsys-meminfo-perl,
  libnet-dns-perl,
  libproc-background-perl,
  libproc-processtable-perl,
  libemail-valid-perl,
  libnet-smtps-perl,
  libmail-imapclient-perl,
  libnet-ldap-perl,
  libemail-valid-perl,
  libjson-perl,
  novnc,
  confget,
  adduser
Recommends: ${misc:Recommends}
Description: Remote desktop service with virtual machines in a browser.
 A remote desktop service that launches virtual machines and displays
 them in your browser. Place virtual machine files (ISO, QCOW2, VDI,
 VMDK...) into /var/lib/qemu-web-desktop/machines, add their name in
 the /etc/qemu-web-desktop/machines.conf file, and run qwdctl
 refresh. You can tune the service settings in the
 /etc/qemu-web-desktop/config.pl
 .
 Once installed, connect to http://server/qemu-web-desktop

## qemu-web-desktop 21.11.30%2Bds1

=== debian/changelog ===
qemu-web-desktop (21.11.30+ds1-1) unstable; urgency=medium

  * Repack upstream tarball to exclude debian/ directory in addition to VM
    images.

 -- Roland Mas <lolando@debian.org>  Wed, 01 Dec 2021 19:08:14 +0100

qemu-web-desktop (21.11.30-1) unstable; urgency=medium

  * Add watch file.
  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Wed, 01 Dec 2021 17:24:26 +0100

qemu-web-desktop (21.08.10-5) unstable; urgency=medium

  * Source-only upload for migration to testing.

 -- Roland Mas <lolando@debian.org>  Wed, 22 Sep 2021 21:01:37 +0200

qemu-web-desktop (21.08.10-4) unstable; urgency=medium

  * Make postrm more robust (thanks, piuparts).

 -- Roland Mas <lolando@debian.org>  Wed, 22 Sep 2021 20:05:31 +0200

qemu-web-desktop (21.08.10-3) unstable; urgency=medium

  * Remove dependency on qemu, but suggest qemu-system for users that need
    full flexibility (closes: #989638, #992950).

 -- Roland Mas <lolando@debian.org>  Tue, 21 Sep 2021 21:32:11 +0200

qemu-web-desktop (21.08.10-2) unstable; urgency=medium

  * Add Frédéric-Emmanuel Picca to Uploaders.
  * Add remove unused dirs on purge (thanks, piuparts).

 -- Roland Mas <lolando@debian.org>  Fri, 10 Sep 2021 17:27:14 +0200

qemu-web-desktop (21.08.10-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Sat, 14 Aug 2021 11:30:06 +0200

## qemu-web-desktop 21.11.30+ds1

=== Makefile ===
#! /usr/bin/make -f

VERSION=$(shell awk -F= '/config{version}[[:space:]]*=/ {print $$2}' src/cgi-bin/qemu-web-desktop.pl | sed -e 's/;.*//' -e 's/"//g' -e 's/[[:space:]]*//g' | tail -1 )

dist:
	tar --create \
		--auto-compress \
		--file=../qemu-web-desktop-$(VERSION).tar.gz \
		--transform=s,^./,qemu-web-desktop-$(VERSION)/, \
		--exclude=./src/html/desktop/machines \
		--exclude=./.git* \
		--exclude=*~ \
		--exclude=./debian \
		.

=== src/Makefile ===
--- 
+++ 
@@ -23,7 +23,6 @@
 	install -D -d $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
 	install -D cgi-bin/qemu-web-desktop.pl $(DESTDIR)$(prefix)/usr/lib/cgi-bin/qemu-web-desktop.pl
 	install -D bin/qwdctl $(DESTDIR)$(prefix)/usr/bin
-	ln -s $(prefix)/var/lib/qemu-web-desktop/machines.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html
 	# configure accounts and permissions
 	chmod 755 /etc/qemu-ifup
 	adduser --system qemu-web-desktop
@@ -38,6 +37,8 @@
 	a2enmod include
 	service apache2 restart
 	qwdctl download
+	ln -s $(prefix)/var/lib/qemu-web-desktop/machines.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html
+	ln -s $(prefix)/var/lib/qemu-web-desktop/mounts.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html
 
 uninstall:
 	-rm -rf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: science
 Priority: optional
 Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
-Uploaders: Roland Mas <lolando@debian.org>, Emmanuel Farhi <emmanuel.farhi@synchrotron-soleil.fr>
+Uploaders: Roland Mas <lolando@debian.org>, Emmanuel Farhi <emmanuel.farhi@synchrotron-soleil.fr>, Frédéric-Emmanuel Picca <picca@debian.org>
 Build-Depends: debhelper (>= 12), dh-apache2, dh-sysuser, pandoc
 Standards-Version: 4.1.2
 Vcs-Browser: https://salsa.debian.org/debian/qemu-web-desktop
@@ -20,7 +20,6 @@
   qemu-system-arm [arm64],
   qemu-system-ppc [ppc64el],
   bridge-utils,
-  qemu,
   iptables,
   dnsmasq,
   libcgi-pm-perl,
@@ -41,6 +40,7 @@
   confget,
   adduser
 Recommends: ${misc:Recommends}
+Suggests: qemu-system
 Description: Remote desktop service with virtual machines in a browser.
  A remote desktop service that launches virtual machines and displays
  them in your browser. Place virtual machine files (ISO, QCOW2, VDI,

=== debian/watch ===
version=4
opts=\
repack,repacksuffix=+ds1,dversionmangle=auto \
https://gitlab.com/soleil-data-treatment/soleil-software-projects/remote-desktop/-/tags?sort=updated_desc archive/v@ANY_VERSION@/remote-desktop-v?[\d.]+\S*@ARCHIVE_EXT@

## qemu-web-desktop 22.04.22

=== src/Makefile ===
# Makefile to install qemu-web-desktop.
# just type: make install
#
# required:
#   apache2 libapache2-mod-perl2 novnc websockify qemu-kvm bridge-utils qemu
#   iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl
#   libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget
#   libproc-background-perl libproc-processtable-perl libemail-valid-perl 
#   libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl 
#   libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk
#
# NOTES:
#   you may have to tune the path to /etc/apache2/conf-available/serve-cgi-bin.conf
#   or other locations. The current makefile works on Debian-class systems.

all:

install:
	install -D -d $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D -d $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	install -D -d $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	install -D -d $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	install -D -d $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	install -D html/desktop/index.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D html/desktop/style.css $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D html/desktop/images/* $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	install -D html/desktop/machines/* $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	install -D cgi-bin/qemu-web-desktop.pl $(DESTDIR)$(prefix)/usr/lib/cgi-bin/qemu-web-desktop.pl
	install -D bin/qwdctl $(DESTDIR)$(prefix)/usr/bin/
	install -D machines.conf $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	install -D config.pl $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	# configure accounts and permissions
	chmod 755 /etc/qemu-ifup
	adduser --system --home $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop --force-badname _qemu-web-desktop
	chown -R _qemu-web-desktop $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
	find $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html -type f -exec chmod a+r {} +
	find $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html -type d -exec chmod a+rx {} +
	chmod 755 $(DESTDIR)$(prefix)/usr/lib/cgi-bin/qemu-web-desktop.pl
	# add apache configuration for cgi perl
	install apache.conf $(DESTDIR)$(prefix)/etc/apache2/conf-available/qemu-web-desktop.conf
	a2enconf qemu-web-desktop
	a2enmod cgi
	a2enmod include
	service apache2 restart
	qwdctl download
	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	ln -sf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop $(DESTDIR)$(prefix)/var/www/html/
	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines $(DESTDIR)$(prefix)/var/www/html/desktop/

uninstall:
	-rm -rf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop
	-rm -f  $(DESTDIR)$(prefix)/usr/lib/cgi-bin/qemu-web-desktop.pl
	-rm -rf $(DESTDIR)$(prefix)/var/www/html/desktop/
	-rm -rf $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	-rm -rf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/
	-rm $(DESTDIR)$(prefix)/etc/apache2/conf-available/qemu-web-desktop.conf
	deluser _qemu-web-desktop

.PHONY: all install uninstall

## qemu-web-desktop 22.04.22-1+ds1

=== debian/changelog ===
qemu-web-desktop (22.04.22-1+ds1-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Mon, 02 May 2022 16:55:59 +0200

qemu-web-desktop (22.04.17+ds1-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Tue, 19 Apr 2022 14:49:22 +0200

## qemu-web-desktop 22.09.16+ds1

=== debian/changelog ===
qemu-web-desktop (22.09.16+ds1-3) unstable; urgency=medium

  * Bug fix: "please add support for riscv64", thanks to Bo YU (Closes: #1016469).

 -- Roland Mas <lolando@debian.org>  Tue, 04 Oct 2022 09:14:10 +0200

qemu-web-desktop (22.09.16+ds1-2) unstable; urgency=medium

  * Backport two patches from upstream.

 -- Roland Mas <lolando@debian.org>  Wed, 28 Sep 2022 18:08:11 +0200

qemu-web-desktop (22.09.16+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Drop debian/patches (merged upstream).

 -- Roland Mas <lolando@debian.org>  Tue, 20 Sep 2022 19:39:15 +0200

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Homepage: https://gitlab.com/soleil-data-treatment/soleil-software-projects/remote-desktop
 
 Package: qemu-web-desktop
-Architecture: amd64 ppc64el arm64
+Architecture: amd64 ppc64el arm64 riscv64
 Depends: ${shlibs:Depends}, ${misc:Depends},
   apache2,
   libapache2-mod-perl2,
@@ -37,6 +37,7 @@
   libemail-valid-perl,
   libjson-perl,
   novnc,
+  guestfs-tools,
   confget,
   adduser
 Recommends: ${misc:Recommends}

## qemu-web-desktop 23.02.16+ds1

=== src/Makefile ===
--- 
+++ 
@@ -8,6 +8,7 @@
 #   libproc-background-perl libproc-processtable-perl libemail-valid-perl 
 #   libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl 
 #   libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk
+#   libtext-qrcode-perl
 #
 # NOTES:
 #   you may have to tune the path to /etc/apache2/conf-available/serve-cgi-bin.conf
@@ -33,6 +34,7 @@
 	chmod 755 /etc/qemu-ifup
 	adduser --system --home $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop --force-badname _qemu-web-desktop
 	chown -R _qemu-web-desktop $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
+	chmod a+xr $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
 	find $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html -type f -exec chmod a+r {} +
 	find $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html -type d -exec chmod a+rx {} +
 	chmod 755 $(DESTDIR)$(prefix)/usr/lib/cgi-bin/qemu-web-desktop.pl

=== debian/changelog ===
qemu-web-desktop (23.02.16+ds1-1) unstable; urgency=medium

  * New upstream release.
  * Add new Depends: libtext-qrcode-perl.
  * Remove unneeded patch (initially picked from upstream).

 -- Roland Mas <lolando@debian.org>  Wed, 15 Feb 2023 19:57:30 +0100

## qemu-web-desktop 23.06.22+ds1

=== debian/changelog ===
qemu-web-desktop (23.06.22+ds1-2~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports

 -- Picca Frédéric-Emmanuel <picca@debian.org>  Fri, 24 Nov 2023 15:44:20 +0100

qemu-web-desktop (23.06.22+ds1-2) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Wed, 04 Oct 2023 11:39:07 +0200

=== debian/control ===
--- 
+++ 
@@ -22,6 +22,7 @@
   bridge-utils,
   iptables,
   dnsmasq,
+  guestfs-tools,
   libcgi-pm-perl,
   liblist-moreutils-perl,
   libsys-cpu-perl,
@@ -36,8 +37,8 @@
   libnet-ldap-perl,
   libemail-valid-perl,
   libjson-perl,
+  libtext-qrcode-perl,
   novnc,
-  guestfs-tools,
   confget,
   adduser
 Recommends: ${misc:Recommends}

## qemu-web-desktop 24.01.19+ds1

=== Makefile ===
--- 
+++ 
@@ -12,3 +12,5 @@
 		--exclude=*~ \
 		--exclude=./debian \
 		.
+deb:
+	debuild -b

=== src/Makefile ===
--- 
+++ 
@@ -48,6 +48,9 @@
 	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
 	ln -sf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop $(DESTDIR)$(prefix)/var/www/html/
 	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines $(DESTDIR)$(prefix)/var/www/html/desktop/
+	
+test:
+	perl src/cgi-bin/qemu-web-desktop.pl --dir_service=src/html/desktop --dir_html=src/html --dir_snapshots=/tmp --dir_machines=src/html/desktop/machines/ --oneshot=1
 
 uninstall:
 	-rm -rf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop

=== debian/changelog ===
qemu-web-desktop (24.01.19+ds1-3) unstable; urgency=medium

  * Bug fix: "qemu-web-desktop： Please add loong64 binary output", thanks
    to yalingfang (Closes: #1060125). 

 -- Roland Mas <lolando@debian.org>  Tue, 06 Feb 2024 15:27:45 +0100

qemu-web-desktop (24.01.19+ds1-2) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Wed, 31 Jan 2024 11:12:49 +0100

qemu-web-desktop (24.01.12+ds1-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Fri, 19 Jan 2024 15:13:19 +0100

=== debian/control ===
--- 
+++ 
@@ -10,7 +10,7 @@
 Homepage: https://gitlab.com/soleil-data-treatment/soleil-software-projects/remote-desktop
 
 Package: qemu-web-desktop
-Architecture: amd64 ppc64el arm64 riscv64
+Architecture: amd64 ppc64el arm64 riscv64 loong64
 Depends: ${shlibs:Depends}, ${misc:Depends},
   apache2,
   libapache2-mod-perl2,
@@ -19,6 +19,7 @@
   qemu-system-x86 [amd64],
   qemu-system-arm [arm64],
   qemu-system-ppc [ppc64el],
+  qemu-system-misc [loong64],
   bridge-utils,
   iptables,
   dnsmasq,

=== debian/rules ===
#!/usr/bin/make -f

SYSEMULATOR=qemu-system-x86_64
ifeq ($(DEB_HOST_ARCH),arm64)
  SYSEMULATOR=qemu-system-aarch64
endif
ifeq ($(DEB_HOST_ARCH),ppc64el)
  SYSEMULATOR=qemu-system-ppc64
endif


%:
	dh $@ --with apache2 --with sysuser

override_dh_auto_build:
	mkdir build
	sed -e 's/qemu-system-x86_64/$(SYSEMULATOR)/' src/config.pl > build/config.pl
	cp src/apache.conf build/qemu-web-desktop.conf
	pandoc -s -o build/qwdctl.1 src/qwdctl.md

override_dh_install:
	dh_install

override_dh_clean:
	rm -rf build
	dh_clean

## qemu-web-desktop 24.07.12+ds1

=== debian/changelog ===
qemu-web-desktop (24.07.12+ds1-2) unstable; urgency=medium

  * Move to dh_installsysusers (thanks, Luca Boccassi!).

 -- Roland Mas <lolando@debian.org>  Tue, 16 Jul 2024 11:48:07 +0200

qemu-web-desktop (24.07.12+ds1-1) unstable; urgency=medium

  * New upstream release.

 -- Roland Mas <lolando@debian.org>  Sun, 14 Jul 2024 18:18:46 +0200

qemu-web-desktop (24.01.19+ds1-4) unstable; urgency=medium

  * Add DARTS to the package description for better findability.

 -- Roland Mas <lolando@debian.org>  Tue, 26 Mar 2024 11:16:58 +0100

## qemu-web-desktop 25.01.25+ds1

=== Makefile ===
--- 
+++ 
@@ -13,4 +13,13 @@
 		--exclude=./debian \
 		.
 deb:
-	debuild -b
+	@echo " Building Debian package"
+	# requires: git-buildpackage dh-apache2 dh-sysuser devscripts
+	-rm -rf debian build
+	cp -r packaging/debian .
+	# remove too big ISO
+	mv src/html/desktop/machines/slax.iso .
+	debuild -b || true
+	rm -rf debian
+	mv slax.iso src/html/desktop/machines/slax.iso
+	@echo "[OK] Build deb"

=== src/Makefile ===
--- 
+++ 
@@ -13,8 +13,31 @@
 # NOTES:
 #   you may have to tune the path to /etc/apache2/conf-available/serve-cgi-bin.conf
 #   or other locations. The current makefile works on Debian-class systems.
+#
+# make install
+#   install qemu-web-desktop
+# make deps
+#   install Debian/Ubuntu dependencies (before make install)
+# make test
+#   test
+# make deb
+#   build debian package
 
 all:
+
+# alt man generation: pandoc -s -o qwdctl.1 --to man -f markdown-smart qwdctl.md
+
+help:
+	@help2man -o qwdctl.1 --no-discard-stderr -n 'control qemu-web-desktop' bin/qwdctl || true
+	@pandoc ../README.md --to pdf > README.pdf || echo "WARNING: skip pdf doc (missing pandoc)"
+	@echo "Usage: install qemu-web-desktop"
+	@echo "make install"
+	@echo "  install qemu-web-desktop"
+	@echo "make deb"
+	@echo "  create debian package"
+
+deps:
+	sudo apt install apache2 libapache2-mod-perl2 novnc websockify qemu-kvm bridge-utils qemu iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget libproc-background-perl libproc-processtable-perl libemail-valid-perl  libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk libtext-qrcode-perl libnet-ssh2-perl
 
 install:
 	install -D -d $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
@@ -22,6 +45,7 @@
 	install -D -d $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
 	install -D -d $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
 	install -D -d $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
+	install -D -d $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
 	install -D html/desktop/index.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
 	install -D html/desktop/style.css $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
 	install -D html/desktop/images/* $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
@@ -30,6 +54,8 @@
 	install -D bin/qwdctl $(DESTDIR)$(prefix)/usr/bin/
 	install -D machines.conf $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
 	install -D config.pl $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
+	install -D qwdctl.1  $(DESTDIR)$(prefix)/usr/share/man/man1/qwdctl.1
+	install -D README.pdf $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
 	# configure accounts and permissions
 	chmod 755 /etc/qemu-ifup
 	adduser --system --home $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop --force-badname _qemu-web-desktop
@@ -43,14 +69,15 @@
 	a2enconf qemu-web-desktop
 	a2enmod cgi
 	a2enmod include
-	service apache2 restart
+	apachectl restart
 	qwdctl download
 	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines.html $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
 	ln -sf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop $(DESTDIR)$(prefix)/var/www/html/
 	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines $(DESTDIR)$(prefix)/var/www/html/desktop/
 	
 test:
-	perl src/cgi-bin/qemu-web-desktop.pl --dir_service=src/html/desktop --dir_html=src/html --dir_snapshots=/tmp --dir_machines=src/html/desktop/machines/ --oneshot=1
+	timeout 30 perl cgi-bin/qemu-web-desktop.pl --dir_snapshots=/tmp --dir_cfg=/tmp --dir_machines=html/desktop/machines/ --oneshot=1 --machine=TinyCore-current.iso
+	@echo Test OK
 
 uninstall:
 	-rm -rf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop
@@ -58,7 +85,8 @@
 	-rm -rf $(DESTDIR)$(prefix)/var/www/html/desktop/
 	-rm -rf $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
 	-rm -rf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/
-	-rm $(DESTDIR)$(prefix)/etc/apache2/conf-available/qemu-web-desktop.conf
+	-rm -f  $(DESTDIR)$(prefix)/etc/apache2/conf-available/qemu-web-desktop.conf
+	-rm -f  $(DESTDIR)$(prefix)/usr/share/man/man1/qwdctl.*
 	deluser _qemu-web-desktop
 
 .PHONY: all install uninstall

=== debian/changelog ===
qemu-web-desktop (25.01.25+ds1-1) unstable; urgency=medium

  [ Emmanuel Farhi ]
  * New upstream version 25.01.25+ds1

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Sun, 16 Feb 2025 15:47:34 +0100

## qemu-web-desktop 25.02.28+ds1

=== src/Makefile ===
# Makefile to install qemu-web-desktop.
# just type: make install
#
# required:
#   apache2 libapache2-mod-perl2 novnc websockify qemu-kvm bridge-utils qemu
#   iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl
#   libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget
#   libproc-background-perl libproc-processtable-perl libemail-valid-perl 
#   libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl 
#   libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk
#   libtext-qrcode-perl
#
# NOTES:
#   you may have to tune the path to /etc/apache2/conf-available/serve-cgi-bin.conf
#   or other locations. The current makefile works on Debian-class systems.
#
# make install
#   install   qemu-web-desktop
# make config
#   configure qemu-web-desktop
# make deps
#   install dependencies (before make install)
# make test
#   test
# make deb
#   build debian package

# alt man generation: pandoc -s -o qwdctl.1 --to man -f markdown-smart qwdctl.md

ARCH=

# auto detect system type
ifneq ("$(wildcard /etc/debian_version)","")
  ARCH = Debian
  $(info Detected Debian-type system)
else ifneq ("$(wildcard /etc/redhat-release)","")
  ARCH = RedHat
  $(info Detected RedHat-type system)
else ifneq ("$(wildcard /etc/arch-release)","")
  ARCH = Arch
  $(info Detected Arch-type system)
endif

ifeq ($(ARCH),Debian)
  DIR_CGI_BIN         = /usr/lib/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/apache2/conf-available
  APACHE_CONF         =
  DIR_WWW             = /var/www/html
else ifeq ($(ARCH),RedHat)
  DIR_CGI_BIN         = /var/www/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/httpd/conf.d/
  APACHE_CONF         = /etc/httpd/conf/httpd.conf
  DIR_WWW             = /var/www/html
else ifeq ($(ARCH),Arch)
  DIR_CGI_BIN         = /srv/http/cgi-bin
  DIR_APACHE_CONF_QWD = /etc/httpd/conf/extra/
  APACHE_CONF         = /etc/httpd/conf/httpd.conf
  DIR_WWW             = /srv/http
else
  $(error Undefined target. Set system type with: make install ARCH=Debian|RedHat|Arch)
endif

all:

help:
	@help2man -o qwdctl.1 --no-discard-stderr -n 'control qemu-web-desktop' bin/qwdctl || true
	@pandoc ../README.md --to pdf > README.pdf || echo "WARNING: skip pdf doc (missing pandoc)"
	@echo "Usage: install qemu-web-desktop"
	@echo "make deps"
	@echo "  install dependencies"
	@echo "make install"
	@echo "  install qemu-web-desktop"
	@echo "make deb"
	@echo "  create debian package"

# ------------------------------------------------------------------------------
# dependencies

deps:
	@echo "Installing $(ARCH)-class dependencies"
ifeq ($(ARCH),Debian)
	sudo apt install apache2 libapache2-mod-perl2 novnc websockify qemu-kvm bridge-utils qemu iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget libproc-background-perl libproc-processtable-perl libemail-valid-perl  libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk libtext-qrcode-perl libnet-ssh2-perl
else ifeq ($(ARCH),Arch)
	@echo "NOTE: You need 'yay' to be installed, and the AUR to be available."
	yay -Sy python-numpy python-setuptools mod_itk apache qemu-desktop bridge-utils qemu-img dnsmasq guestfs-tools perl-cgi perl-list-moreutils perl-sys-cpu perl-sys-meminfo perl-net-dns perl-proc-processtable perl-mail-imapclient perl-ldap perl-json perl-libwww mod_perl novnc websockify perl-proc-background perl-email-valid perl-net-smtps perl-text-qrcode perl-net-ssh2 confget
else ifeq ($(ARCH),RedHat)
	sudo dnf install mod_perl httpd-itk novnc python3-websockify crudini guestfs-tools perl-CGI perl-List-MoreUtils perl-Sys-CPU perl-Sys-MemInfo perl-Net-DNS perl-Proc-ProcessTable perl-Email-Valid perl-Net-SMTPS perl-Mail-IMAPClient perl-LDAP perl-JSON perl-libwww-perl perl-Text-QRCode perl-Net-SSH2 perl-Net-Ping perl-CPAN
	sudo cpan Proc::Background
endif
	@echo "[OK] Dependencies installed for $(ARCH)"
	@echo "You may now proceed with: make install"

# ------------------------------------------------------------------------------
# install

install: copy config

copy:
	@echo "Installing QWD files for $(ARCH)-type system"
	# create directories
	install -D -d                       $(DESTDIR)$(prefix)/etc/qemu-web-desktop
	install -D -d                       $(DESTDIR)$(prefix)/usr/bin
	install -D -d                       $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D -d                       $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	install -D -d                       $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	install -D -d                       $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	install -D -d                       $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	# common install
	install -D machines.conf            $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	install -D config.pl                $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	install -D html/desktop/index.html  $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D html/desktop/style.css   $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	install -D html/desktop/images/*    $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/images
	install -D qwdctl.1                 $(DESTDIR)$(prefix)/usr/share/man/man1/qwdctl.1
	install -D README.pdf               $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	install -D bin/qwdctl               $(DESTDIR)$(prefix)/usr/bin/
	install -D html/desktop/machines/*  $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	-mv $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop/machines/* $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines/
	chmod a+wxr                         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
	chmod a+xrw                         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines
	chmod u+xrw                         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/snapshots
	find                                $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html -type f -exec chmod a+r {} +
	find                                $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html -type d -exec chmod a+rx {} +
	# system specific locations
	install -D -d                          $(DESTDIR)$(prefix)$(DIR_WWW)
	install -D -d                          $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)
	install apache.conf                    $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
	install -D -d                          $(DESTDIR)$(prefix)$(DIR_CGI_BIN)
	install -D cgi-bin/qemu-web-desktop.pl $(DESTDIR)$(prefix)$(DIR_CGI_BIN)/qemu-web-desktop.pl
	chmod 755                              $(DESTDIR)$(prefix)$(DIR_CGI_BIN)/qemu-web-desktop.pl
	# system specific actions
ifneq ($(ARCH),Debian)
	sed -i 's|Alias /qemu-web-desktop|#Alias /qemu-web-desktop|'  $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
	sed -i 's/config{service_port_multiple}    = 0/config{service_port_multiple}    = 1/' $(DESTDIR)$(prefix)/etc/qemu-web-desktop//config.pl
	sed -i 's/machines_insert=no/machines_insert=yes/'            $(DESTDIR)$(prefix)/usr/bin/qwdctl
endif
	@echo "[OK] QWD Installation complete for $(ARCH)."
	@echo "You may now proceed with: make config"

# ------------------------------------------------------------------------------
# post-install/auto configure

config:
	@echo "Post QWD installation steps (auto-configure) for $(ARCH)"
	ln -sf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop  $(DESTDIR)$(prefix)$(DIR_WWW)/
	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines        $(DESTDIR)$(prefix)$(DIR_WWW)/desktop/
ifeq ($(ARCH),Debian)
	-adduser --system --home     $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop --force-badname _qemu-web-desktop
	-chown -R _qemu-web-desktop: $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
	systemctl enable  apache2
	a2enconf qemu-web-desktop
	a2enmod  cgi
	a2enmod  include
	systemctl restart apache2
	chmod 755 /etc/qemu-ifup
endif
ifeq ($(ARCH),Arch)
	useradd --system -m --home-dir         $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop --badname _qemu-web-desktop
	chown -R _qemu-web-desktop             $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
	ln -sf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop  $(DESTDIR)$(prefix)$(DIR_WWW)/qemu-web-desktop
	ln -sf $(DESTDIR)$(prefix)/usr/share/webapps/novnc                  $(DESTDIR)$(prefix)/usr/share/novnc
	# MPM ITK requires prefork, that conflicts with mpm_event
	sed -i 's/LoadModule mpm_event/#LoadModule mpm_event/'              $(DESTDIR)$(prefix)$(APACHE_CONF)
	sed -i 's/#LoadModule mpm_prefork/LoadModule mpm_prefork/'          $(DESTDIR)$(prefix)$(APACHE_CONF)
	grep -q "mpm_itk"          $(DESTDIR)$(prefix)$(APACHE_CONF) || echo "LoadModule mpm_itk_module modules/mpm_itk.so" >> $(DESTDIR)$(prefix)$(APACHE_CONF)
	grep -q "qemu-web-desktop" $(DESTDIR)$(prefix)$(APACHE_CONF) || echo "Include conf/extra/qemu-web-desktop.conf" >> $(DESTDIR)$(prefix)$(APACHE_CONF)
	systemctl enable httpd
	systemctl daemon-reload
	systemctl restart httpd
endif
ifeq ($(ARCH),RedHat)
	# There is no available MPM ITK module :-(
	chown -R apache                                                        $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop
	ln -sf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop     $(DESTDIR)$(prefix)$(DIR_WWW)/qemu-web-desktop
	systemctl enable  httpd
	systemctl daemon-reload
	systemctl restart httpd
endif
	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines.html   $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
	qwdctl download
	@echo "[OK] QWD Configuration complete for $(ARCH)."
	@echo "Now connect to       http://localhost/qemu-web-desktop for immediate use."
	@echo "or launch a VM with: qwdctl start VM"
	@echo "or refer to          https://gitlab.com/soleil-data-treatment/soleil-software-projects/qemu-web-desktop"
	@echo "to configure the service."

# ------------------------------------------------------------------------------

test:
	qwdctl stop
	if timeout 10 perl cgi-bin/qemu-web-desktop.pl --dir_snapshots=/tmp --dir_cfg=/tmp --dir_machines=html/desktop/machines/ --oneshot=1 --machine=TinyCore-current.iso = 124; then echo "OK"; fi
	@echo Test OK

uninstall:
	-rm -rf $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
	-rm -rf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop
	-rm -rf $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
	-rm -f  $(DESTDIR)$(prefix)/usr/share/man/man1/qwdctl.*
	-rm -f  $(DESTDIR)$(prefix)/usr/bin/qwdctl
	-rm -rf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/
	-rm -rf $(DESTDIR)$(prefix)$(DIR_WWW)/qemu-web-desktop
	-rm -rf $(DESTDIR)$(prefix)$(DIR_WWW)/desktop
	-rm -f  $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
	-rm -f  $(DESTDIR)$(prefix)$(DIR_CGI_BIN)/qemu-web-desktop.pl
	if [ -e $(DESTDIR)$(prefix)/etc/httpd/conf/httpd.conf ]; then \
	  sed -i 's|Include conf/extra/qemu-web-desktop.conf|#Include conf/extra/qemu-web-desktop.conf|' $(DESTDIR)$(prefix)$(APACHE_CONF); \
	fi
	-apachectl restart
	-killall -9 websockify
	-deluser _qemu-web-desktop || userdel _qemu-web-desktop || true
	@echo "[OK] QWD uninstalled."

.PHONY: all install uninstall
.NOTPARALLEL: copy config

=== debian/changelog ===
qemu-web-desktop (25.02.28+ds1-2) unstable; urgency=medium

  * d/control: Add dependency libnet-ssh2-perl

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Mon, 10 Mar 2025 18:23:51 +0100

qemu-web-desktop (25.02.28+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 25.02.28+ds1

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Fri, 28 Feb 2025 21:29:23 +0100

## qemu-web-desktop 25.04.04+ds1

=== debian/changelog ===
qemu-web-desktop (25.04.04+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 25.04.04+ds1
  * Support for aarch64

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Fri, 04 Apr 2025 17:03:52 +0200

## qemu-web-desktop 25.04.05%2Bds1

=== debian/control ===
Source: qemu-web-desktop
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Roland Mas <lolando@debian.org>, Emmanuel Farhi <emmanuel.farhi.1@gmail.com>, Frédéric-Emmanuel Picca <picca@debian.org>
Build-Depends: debhelper (>= 12), dh-apache2, pandoc
Standards-Version: 4.1.2
Vcs-Browser: https://salsa.debian.org/debian/qemu-web-desktop
Vcs-Git: https://salsa.debian.org/debian/qemu-web-desktop.git
Homepage: https://gitlab.com/soleil-data-treatment/soleil-software-projects/remote-desktop

Package: qemu-web-desktop
Architecture: amd64 ppc64el arm64 riscv64 loong64
Depends: ${shlibs:Depends}, ${misc:Depends},
  apache2,
  libapache2-mod-perl2,
  libapache2-mpm-itk,
  websockify,
  qemu-system-x86 [amd64],
  qemu-system-arm [arm64],
  qemu-system-ppc [ppc64el],
  qemu-system-misc [loong64],
  bridge-utils,
  iptables,
  dnsmasq,
  guestfs-tools,
  libcgi-pm-perl,
  libemail-valid-perl,
  libjson-perl,
  liblist-moreutils-perl,
  libmail-imapclient-perl,
  libnet-dns-perl,
  libnet-ldap-perl,
  libnet-smtps-perl,
  libnet-ssh2-perl,
  libproc-background-perl,
  libproc-processtable-perl,
  libsys-cpuload-perl,
  libsys-cpu-perl,
  libsys-meminfo-perl,
  libtext-qrcode-perl,
  novnc,
  confget,
  adduser
Recommends: ${misc:Recommends}
Suggests: qemu-system
Description: Remote desktop service with virtual machines in a browser (DARTS).
 A remote desktop service that launches virtual machines and displays
 them in your browser. Place virtual machine files (ISO, QCOW2, VDI,
 VMDK...) into /var/lib/qemu-web-desktop/machines, add their name in
 the /etc/qemu-web-desktop/machines.conf file, and run qwdctl
 refresh. You can tune the service settings in the
 /etc/qemu-web-desktop/config.pl
 This project is also named Data Analysis Remote Treatment Service (DARTS).
 .
 Once installed, connect to http://server/qemu-web-desktop

=== debian/rules ===
--- 
+++ 
@@ -10,7 +10,7 @@
 
 
 %:
-	dh $@ --with apache2 --with sysuser
+	dh $@ --with apache2
 
 override_dh_auto_build:
 	mkdir build
@@ -21,6 +21,10 @@
 override_dh_install:
 	dh_install
 
+# Can be dropped in compat level 13
+execute_after_dh_installinit:
+	dh_installsysusers
+
 override_dh_clean:
 	rm -rf build
 	dh_clean

## qemu-web-desktop 25.04.05+ds1

=== Makefile ===
--- 
+++ 
@@ -1,4 +1,9 @@
 #! /usr/bin/make -f
+
+# qemu-web-desktop project Makefile
+# This is not the one you search for.
+#
+# Use: cd src; sudo make install
 
 VERSION=$(shell awk -F= '/config{version}[[:space:]]*=/ {print $$2}' src/cgi-bin/qemu-web-desktop.pl | sed -e 's/;.*//' -e 's/"//g' -e 's/[[:space:]]*//g' | tail -1 )
 
@@ -20,6 +25,6 @@
 	# remove too big ISO
 	mv src/html/desktop/machines/slax.iso .
 	debuild -b || true
-	rm -rf debian
+	rm -rf debian build
 	mv slax.iso src/html/desktop/machines/slax.iso
 	@echo "[OK] Build deb"

=== src/Makefile ===
--- 
+++ 
@@ -9,10 +9,11 @@
 #   libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl 
 #   libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk
 #   libtext-qrcode-perl
+# on ARM64, an EFI boot is required (e.g. qemu-efi-aarch64)
 #
 # NOTES:
 #   you may have to tune the path to /etc/apache2/conf-available/serve-cgi-bin.conf
-#   or other locations. The current makefile works on Debian-class systems.
+#   or other locations. The current makefile works best on Debian-class systems.
 #
 # make install
 #   install   qemu-web-desktop
@@ -24,6 +25,8 @@
 #   test
 # make deb
 #   build debian package
+# make help
+#   build the documentation files (requires help2man pandoc librsvg2-bin texlive-latex-base  	texlive-latex-recommended)
 
 # alt man generation: pandoc -s -o qwdctl.1 --to man -f markdown-smart qwdctl.md
 
@@ -39,7 +42,19 @@
 else ifneq ("$(wildcard /etc/arch-release)","")
   ARCH = Arch
   $(info Detected Arch-type system)
-endif
+else ifneq ("$(wildcard /etc/bashrc_Apple_Terminal)","")
+  ARCH = Darwin
+  $(info Detected Darwin-type system - Apple)
+endif
+
+# auto detect type of CPU (for installation)
+uname_m := $(shell uname -m)
+QEMU.i386    := qemu-system-x86
+QEMU.x86_64  := qemu-system-x86
+QEMU.aarch64 := qemu-system-arm
+QEMU.arm64   := qemu-system-arm
+
+QEMU ?= $(QEMU.$(uname_m))
 
 ifeq ($(ARCH),Debian)
   DIR_CGI_BIN         = /usr/lib/cgi-bin
@@ -56,6 +71,11 @@
   DIR_APACHE_CONF_QWD = /etc/httpd/conf/extra/
   APACHE_CONF         = /etc/httpd/conf/httpd.conf
   DIR_WWW             = /srv/http
+else ifeq ($(ARCH),Darwin)
+  DIR_CGI_BIN         = /opt/homebrew/var/www/cgi-bin      #/Library/WebServer/CGI-Executables
+  DIR_APACHE_CONF_QWD = /opt/homebrew/etc/httpd/extra/     # /etc/apache2/extra/
+  APACHE_CONF         = /opt/homebrew/etc/httpd/httpd.conf # /etc/apache2/httpd.conf
+  DIR_WWW             = /opt/homebrew/var/www              # /Library/WebServer/Documents 
 else
   $(error Undefined target. Set system type with: make install ARCH=Debian|RedHat|Arch)
 endif
@@ -79,13 +99,28 @@
 deps:
 	@echo "Installing $(ARCH)-class dependencies"
 ifeq ($(ARCH),Debian)
-	sudo apt install apache2 libapache2-mod-perl2 novnc websockify qemu-kvm bridge-utils qemu iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget libproc-background-perl libproc-processtable-perl libemail-valid-perl  libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk libtext-qrcode-perl libnet-ssh2-perl
+	sudo apt install apache2 libapache2-mod-perl2 novnc websockify $(QEMU) qemu-utils bridge-utils iptables dnsmasq libcgi-pm-perl liblist-moreutils-perl libsys-cpu-perl libsys-cpuload-perl libsys-meminfo-perl libnet-dns-perl confget libproc-background-perl libproc-processtable-perl libemail-valid-perl  libnet-smtps-perl libmail-imapclient-perl libnet-ldap-perl libemail-valid-perl libjson-perl libwww-perl libguestfs-tools libapache2-mpm-itk libtext-qrcode-perl libnet-ssh2-perl
+	if [ "$(uname_m)" = "aarch64" -o "$(uname_m)" = "arm64" ]; then sudo apt install qemu-efi-aarch64; fi
 else ifeq ($(ARCH),Arch)
 	@echo "NOTE: You need 'yay' to be installed, and the AUR to be available."
 	yay -Sy python-numpy python-setuptools mod_itk apache qemu-desktop bridge-utils qemu-img dnsmasq guestfs-tools perl-cgi perl-list-moreutils perl-sys-cpu perl-sys-meminfo perl-net-dns perl-proc-processtable perl-mail-imapclient perl-ldap perl-json perl-libwww mod_perl novnc websockify perl-proc-background perl-email-valid perl-net-smtps perl-text-qrcode perl-net-ssh2 confget
 else ifeq ($(ARCH),RedHat)
-	sudo dnf install mod_perl httpd-itk novnc python3-websockify crudini guestfs-tools perl-CGI perl-List-MoreUtils perl-Sys-CPU perl-Sys-MemInfo perl-Net-DNS perl-Proc-ProcessTable perl-Email-Valid perl-Net-SMTPS perl-Mail-IMAPClient perl-LDAP perl-JSON perl-libwww-perl perl-Text-QRCode perl-Net-SSH2 perl-Net-Ping perl-CPAN
+	@echo "NOTE: This system-type is not fully supported"
+	sudo dnf install mod_perl novnc python3-websockify crudini guestfs-tools perl-CGI perl-List-MoreUtils perl-Sys-CPU perl-Sys-MemInfo perl-Net-DNS perl-Proc-ProcessTable perl-Email-Valid perl-Net-SMTPS perl-Mail-IMAPClient perl-LDAP perl-JSON perl-libwww-perl perl-Text-QRCode perl-Net-SSH2 perl-Net-Ping perl-CPAN
 	sudo cpan Proc::Background
+else ifeq ($(ARCH),Darwin)
+	@echo "NOTE: This system-type is not properly supported"
+	brew install qemu apache2 perl python3 python-setuptools
+	PERL_MM_OPT="INSTALL_BASE=~/perl5" cpan local::lib
+	eval "$(perl -I~/perl5/lib/perl5 -Mlocal::lib=~/perl5)"
+	cpan CGI Cwd File::Temp File::Path File::Basename File::Copy List::MoreUtils
+	cpan List::Util IO::Socket::INET IO::Socket::IP JSON Proc::Background
+	cpan Proc::ProcessTable Proc::Killfam Sys::CPU Sys::MemInfo Email::Valid
+	cpan Mail::IMAPClient LWP::UserAgent Net::Ping Net::SMTPS Net::LDAP Net::SSH2 URI
+	# install websockify
+	$(cd /tmp; wget https://github.com/novnc/websockify/archive/refs/tags/v0.13.0.tar.gz; tar xzf v0.13.0.tar.gz; cd websockify-0.13.0; python3 setup.py build; python3 setup.py build; )
+	# install novnc
+	if [ ! -d /opt/homebrew/share/novnc ]; then $(cd /tmp; wget https://github.com/novnc/noVNC/archive/refs/tags/v1.6.0.tar.gz; tar xzf v1.6.0.tar.gz; cp -r noVNC-1.6.0 /opt/homebrew/share/novnc); fi
 endif
 	@echo "[OK] Dependencies installed for $(ARCH)"
 	@echo "You may now proceed with: make install"
@@ -175,41 +210,10 @@
 	systemctl enable  httpd
 	systemctl daemon-reload
 	systemctl restart httpd
+	# SElinux permissions: allow port 6080 (update if config.pl changes)
+	semanage port -a -t http_port_t -p tcp 6080
+	semanage port -a -t http_port_t -p tcp 5901
+	setsebool -P httpd_can_network_relay   1
+	setsebool -P httpd_can_network_connect 1
 endif
 	ln -sf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/machines.html   $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop/html/desktop
-	qwdctl download
-	@echo "[OK] QWD Configuration complete for $(ARCH)."
-	@echo "Now connect to       http://localhost/qemu-web-desktop for immediate use."
-	@echo "or launch a VM with: qwdctl start VM"
-	@echo "or refer to          https://gitlab.com/soleil-data-treatment/soleil-software-projects/qemu-web-desktop"
-	@echo "to configure the service."
-
-# ------------------------------------------------------------------------------
-
-test:
-	qwdctl stop
-	if timeout 10 perl cgi-bin/qemu-web-desktop.pl --dir_snapshots=/tmp --dir_cfg=/tmp --dir_machines=html/desktop/machines/ --oneshot=1 --machine=TinyCore-current.iso = 124; then echo "OK"; fi
-	@echo Test OK
-
-uninstall:
-	-rm -rf $(DESTDIR)$(prefix)/etc/qemu-web-desktop/
-	-rm -rf $(DESTDIR)$(prefix)/usr/share/qemu-web-desktop
-	-rm -rf $(DESTDIR)$(prefix)/usr/share/doc/qemu-web-desktop
-	-rm -f  $(DESTDIR)$(prefix)/usr/share/man/man1/qwdctl.*
-	-rm -f  $(DESTDIR)$(prefix)/usr/bin/qwdctl
-	-rm -rf $(DESTDIR)$(prefix)/var/lib/qemu-web-desktop/
-	-rm -rf $(DESTDIR)$(prefix)$(DIR_WWW)/qemu-web-desktop
-	-rm -rf $(DESTDIR)$(prefix)$(DIR_WWW)/desktop
-	-rm -f  $(DESTDIR)$(prefix)$(DIR_APACHE_CONF_QWD)/qemu-web-desktop.conf
-	-rm -f  $(DESTDIR)$(prefix)$(DIR_CGI_BIN)/qemu-web-desktop.pl
-	if [ -e $(DESTDIR)$(prefix)/etc/httpd/conf/httpd.conf ]; then \
-	  sed -i 's|Include conf/extra/qemu-web-desktop.conf|#Include conf/extra/qemu-web-desktop.conf|' $(DESTDIR)$(prefix)$(APACHE_CONF); \
-	fi
-	-apachectl restart
-	-killall -9 websockify
-	-deluser _qemu-web-desktop || userdel _qemu-web-desktop || true
-	@echo "[OK] QWD uninstalled."
-
-.PHONY: all install uninstall
-.NOTPARALLEL: copy config
-

=== debian/changelog ===
qemu-web-desktop (25.04.05+ds1-1) unstable; urgency=medium

  [ Emmanuel FARHI ]
  * New upstream version 25.04.05+ds1

 -- Emmanuel Farhi <emmanuel.farhi.1@gmail.com>  Fri, 04 Apr 2025 22:22:12 +0200

=== debian/watch ===
version=4
opts="searchmode=plain,repack,repacksuffix=+ds1,dversionmangle=auto" \
 https://gitlab.com/soleil-data-treatment/soleil-software-projects/@PACKAGE@/tags?sort=updated_desc -/archive/v?\d[\d.]+/@PACKAGE@-@ANY_VERSION@@ARCHIVE_EXT@
